#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2eleven4search.py">
#<abstract4xi abstract = "shoots to direction eleven"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2eleven4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2eleven4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2eleven4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4eleven

global count2ack4eleven
global count2nack4eleven
global count2found4eleven
global count2short4eleven

global current2series4eleven
global candidate2series4eleven

global fileobject4eleven  

global keys2profile4eleven
global key2profile4eleven

global left2find4eleven

global maxsize2ack4eleven    
global maxsize2file4eleven 
global max2short4eleven
global meansize2ack4eleven
global minsize2ack4eleven

global eleven2analyse4search

global profile2fetch4eleven

global right2find4eleven

global sumsize2ack4eleven    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4eleven = VersionKB4Xi['base2shoot4eleven']             # base internet address, None=local url

count2ack4eleven   = 0
count2nack4eleven  = 0
count2found4eleven = 0
count2short4eleven = 0

left2find4eleven = '('

max2short4eleven = VersionKB4Xi['max2short4eleven']
maxsize2file4eleven = VersionKB4Xi['maxsize2file4eleven']
maxsize2ack4eleven  = 0
meansize2ack4eleven = 0
minsize2ack4eleven  = 0

current2series4eleven = "current2series4eleven5dummy"
candidate2series4eleven  = "candidate2series4eleven5dummy"


eleven2analyse4search  = VersionKB4Xi['eleven2analyse4search']

profile2fetch4eleven = {}
profile2fetch4eleven [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4eleven [2] = '.jpg'
keys2profile4eleven = profile2fetch4eleven.keys()

right2find4eleven = ')'

sumsize2ack4eleven  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4eleven" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4eleven(target2explore4eleven):
    global count2ack4eleven
    global count2nack4eleven
    global count2found4eleven
    global count2short4eleven
    
    global fileobject4eleven 
       
    global keys2profile4eleven
    global key2profile4eleven
    
    global left2find4eleven

    global max2short4eleven    
    global maxsize2file4eleven     
    global maxsize2ack4eleven    
    global meansize2ack4eleven
    global minsize2ack4eleven
  
    global candidate2series4eleven
    global current2series4eleven
    
    
    global profile2fetch4eleven                         # extension for files
    
    global right2find4eleven
    
    global sumsize2ack4eleven    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4eleven = count2found4eleven + 1
    ack2debug4eleven = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4eleven)
    
    ack2profile = False
    for key2profile4eleven in keys2profile4eleven:
        if name2target[1] == profile2fetch4eleven[key2profile4eleven]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2ELEVEN4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4eleven
        if ack2debug4eleven is True:
            print("(STEP 0A/33) OF SHOOT2ELEVEN4SEARCH - PATH2INPUT: ", path2input) 
            # F://temp//yophotos//test2eleven//s\syysmetsastys09september2005\syysmetsastys09september2005 (24).JPG   
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2ELEVEN4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4eleven:
            count2nack4eleven = count2nack4eleven + 1
        else:
            count2ack4eleven = count2ack4eleven + 1
            sumsize2ack4eleven = sumsize2ack4eleven + size2file
            if size2file > maxsize2ack4eleven:
                maxsize2ack4eleven = size2file
            if ((size2file < minsize2ack4eleven) or (minsize2ack4eleven == 0)):
                print("(STEP 0B/33) OF SHOOT2ELEVEN4SEARCH - USING MINSIZE2ACK4ELEVEN: ", minsize2ack4eleven, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4ELEVEN:  0  SIZE2FILE:  323812  PATH2INPUT:  F://temp//yophotos//test2eleven//s\syysmetsastys09september2005\syysmetsastys09september2005 (24).JPG
                
                minsize2ack4eleven = size2file
                print("(STEP 0C/33) OF SHOOT2ELEVEN4SEARCH - SET MINSIZE2ACK4ELEVEN TO: ", minsize2ack4eleven, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4ELEVEN TO:  323812  = SIZE2FILE:  323812  PATH2INPUT:  F://temp//yophotos//test2eleven//s\syysmetsastys09september2005\syysmetsastys09september2005 (24).JPG
                # 
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4eleven = target2explore4eleven
            if ack2debug4eleven is True:print("(STEP 1A/33) OF SHOOT2ELEVEN4SEARCH - URL2WEB4ELEVEN: ", url2web4eleven) 
                # URL2WEB4ELEVEN:  F://temp//yophotos//test2eleven//s\syysmetsastys09september2005\syysmetsastys09september2005 (24).JPG
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4eleven,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4eleven = url2web4eleven[0:index2edit] + string2use + url2web4eleven[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4eleven)
            shortname2web4eleven = name2web[0]
            if ack2debug4eleven is True:
                print("(STEP 1B/33) OF SHOOT2ELEVEN4SEARCH - SHORTNAME2WEB4ELEVEN: ", shortname2web4eleven)
                # SHORTNAME2WEB4ELEVEN:  F://temp//yophotos//test2eleven//s/syysmetsastys09september2005/syysmetsastys09september2005 (24)
            
            string2find4eleven = '/'
            ackall2found4eleven = False           
            while 1:
                if ackall2found4eleven is True:
                    break
                else:
                    index2find4eleven=str.find(shortname2web4eleven,string2find4eleven)   
                    if index2find4eleven == -1:
                        ackall2found4eleven = True
                    else:
                        shortname2web4eleven = shortname2web4eleven[index2find4eleven+1:]
                        
            if ack2debug4eleven is True:            
                print("(STEP 1C/33) OF SHOOT2ELEVEN4SEARCH - SHORTNAME2WEB4ELEVEN: ", shortname2web4eleven)
                # SHORTNAME2WEB4ELEVEN:  syysmetsastys09september2005 (24)
                
            ackall2found4eleven = False 
            while 1:
                if ackall2found4eleven is True:
                    break
                else:
                    index2left4eleven=str.find(shortname2web4eleven,left2find4eleven)
                    if index2left4eleven == -1:
                        current2series4eleven = shortname2web4eleven
                        if ack2debug4eleven is True:
                            print("(STEP 2A/33) OF SHOOT2ELEVEN4SEARCH - CURRENT2SERIES4ELEVEN: ", current2series4eleven) 
                            # CURRENT2SERIES4ELEVEN:  syysmetsastys09september2005
                        ackall2found4eleven = True
                         
                    else:
                        index2right4eleven=str.find(shortname2web4eleven,right2find4eleven)
                        if index2right4eleven == -1:
                            ackall2found4eleven = True 
                        else:
                            candidate2series4eleven = shortname2web4eleven[0:index2left4eleven]
                            
                            index3find4eleven=str.find(shortname2web4eleven,current2series4eleven)
                            if index3find4eleven == -1:
                                
                                current2series4eleven = candidate2series4eleven
                                if ack2debug4eleven is True:
                                    print("(STEP 2B/33) OF SHOOT2ELEVEN4SEARCH - CURRENT2SERIES4ELEVEN: ", current2series4eleven) 
                                    # 
                                
                                count2short4eleven = 0
                                fileobject4eleven.write('<br />' + '\n')
                            else:
                                shortname2web4eleven = shortname2web4eleven[index2left4eleven:index2right4eleven+1]
                                if ack2debug4eleven is True:
                                    print("(STEP 2C/33) OF SHOOT2ELEVEN4SEARCH - SHORTNAME2WEB4ELEVEN: ", shortname2web4eleven)
                                    # 
                                
                                count2short4eleven = count2short4eleven + 1
                                if count2short4eleven >= max2short4eleven:
                                    count2short4eleven = 0
                                else:
                                    pass       
                            ackall2found4eleven = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4eleven is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4eleven.write('<br /><b>&raquo;</b><a href="' + url2web4eleven + '" target="_blank">' + shortname2web4eleven + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4eleven = eleven2analyse4search
                if ack2debug4eleven is True:
                    print("(STEP 3A/33) OF SHOOT2ELEVEN4SEARCH - BASE2LOCAL4ELEVEN: ", base2local4eleven)
                    #              
                ack2localtries4eleven = False                   
                while 1:
                    if ack2localtries4eleven is True:
                        break
                    else:
                        index2find4eleven=str.find(url2web4eleven,base2local4eleven)            
                        # 
                        #  
                        if index2find4eleven == -1:
                            ack2localtries4eleven = True
                        else:
                            if ack2debug4eleven is True:
                                print("(STEP 3B/33) OF SHOOT2ELEVEN4SEARCH - BASE2BUILD4ELEVEN: ", base2build4eleven)
                                # 
                            url2web4eleven = base2build4eleven + url2web4eleven[len(base2local4eleven):]
                            if ack2debug4eleven is True:
                                print("(STEP 3C/33) OF SHOOT2ELEVEN4SEARCH - URL2WEB4ELEVEN: ", url2web4eleven)
                                # 
                            
                            if count2short4eleven < 1: 
                                fileobject4eleven.write('<br /><b>&raquo;</b><a href="' + url2web4eleven + '" target="_blank">' + shortname2web4eleven + '</a>' + '\n')
                            else:
                                fileobject4eleven.write('<b>&raquo;</b><a href="' + url2web4eleven + '" target="_blank">' + shortname2web4eleven + '</a>\n')                            
                            ack2localtries4eleven = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2ELEVEN4SEARCH FAILED, FILEOBJECT4ELEVEN-WRITE-FAILED: ", str(fileobject4eleven), time4xi())
      
    else:
        
        count2nack4eleven = count2nack4eleven + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2eleven4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2eleven4search(queue2eleven = None, consumer_channel2eleven = None, publisher_channel2eleven = None, path2eleven = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4eleven
    global count2nack4eleven
    global count2found4eleven
    
    global fileobject4eleven    
    
    global maxsize2ack4eleven    
    global meansize2ack4eleven
    global minsize2ack4eleven
    global sumsize2ack4eleven    
    
    global maxsize2file4eleven 
    
    global profile2fetch4eleven                         # extension for files
    global keys2profile4eleven
    global key2profile4eleven

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2ELEVEN4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2ELEVEN4SEARCH -  QUEUE2ELEVEN: ", queue2eleven)      
    # QUEUE2ELEVEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2ELEVEN4SEARCH -  CONSUMER_CHANNEL2ELEVEN: ", consumer_channel2eleven)
    # CONSUMER_CHANNEL2ELEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2ELEVEN4SEARCH -  PUBLISHER_CHANNEL2ELEVEN: ", publisher_channel2eleven)          
    # PUBLISHER_CHANNEL2ELEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2eleven is None) or (consumer_channel2eleven is None) or (publisher_channel2eleven is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2ELEVEN4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2ELEVEN4SEARCH - QUEUE2ELEVEN: ", queue2eleven)
        print("(STEP 1C/33) OF SHOOT2ELEVEN4SEARCH - CONSUMER_CHANNEL2ELEVEN: ", consumer_channel2eleven) 
        print("(STEP 1D/33) OF SHOOT2ELEVEN4SEARCH - PUBLISHER_CHANNEL2ELEVEN: ", publisher_channel2eleven)
        print("(STEP 1E/33) OF SHOOT2ELEVEN4SEARCH - PATH2ELEVEN: ", path2eleven)     
        
        return
 
    if (not (queue2eleven is None) and not(consumer_channel2eleven is None) and not(publisher_channel2eleven is None) and (path2eleven is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2ELEVEN4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2ELEVEN4SEARCH - QUEUE2ELEVEN: ", queue2eleven)
        print("(STEP 2C/33) OF SHOOT2ELEVEN4SEARCH - CONSUMER_CHANNEL2ELEVEN: ", consumer_channel2eleven) 
        print("(STEP 2D/33) OF SHOOT2ELEVEN4SEARCH - PUBLISHER_CHANNEL2ELEVEN: ", publisher_channel2eleven)
        print("(STEP 2E/33) OF SHOOT2ELEVEN4SEARCH - PATH2ELEVEN: ", path2eleven)     
        return           

    if (not (queue2eleven is None) and not(consumer_channel2eleven is None) and not(publisher_channel2eleven is None) and not(path2eleven is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2ELEVEN4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2ELEVEN4SEARCH - QUEUE2ELEVEN: ", queue2eleven)
        # QUEUE2ELEVEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2ELEVEN4SEARCH - CONSUMER_CHANNEL2ELEVEN: ", consumer_channel2eleven)
        # CONSUMER_CHANNEL2ELEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2ELEVEN4SEARCH - PUBLISHER_CHANNEL2ELEVEN: ", publisher_channel2eleven)
        # PUBLISHER_CHANNEL2ELEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2ELEVEN4SEARCH - PATH2ELEVEN: ", path2eleven)
        # PATH2ELEVEN:  F://temp//yophotos//test2eleven//
       
        print("(STEP 4A/33) OF SHOOT2ELEVEN4SEARCH - STARTING TO WALK PATH2ELEVEN: ", path2eleven)   
        # STARTING TO WALK PATH2ELEVEN:  F://temp//yophotos//test2eleven//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4eleven = None
        try:
            name2index4eleven = "index2xxxxxxxx4yo.html"
            path2index4eleven = path2eleven + name2index4eleven
            print("(Step 4B/33) OF SHOOT2ELEVEN4SEARCH - SET PATH2INDEX4ELEVEN TO: ", path2index4eleven) 
            # SET PATH2INDEX4ELEVEN TO:  F://temp//yophotos//test2eleven//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4ELEVEN: ", path2index4eleven)          
            #                    
        fileobject4eleven = None
        try:
            fileobject4eleven = open(path2index4eleven,'w')
            print("(Step 4C/33) OF SHOOT2ELEVEN4SEARCH - OPENED OUTPUT: ", fileobject4eleven)
            # OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2eleven//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
            
        except:
            print("(Step 4Z2/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4eleven)         
            # 
        try:                
            fileobject4eleven.write('<html>\n')
            
            fileobject4eleven.write('<style type="text/css" media="all">\n')
            fileobject4eleven.write(' @import "http://www.yourelevenxi.org/css/halongbay.css";\n')
            fileobject4eleven.write('</style> \n')
            fileobject4eleven.write('<p>\n')
            fileobject4eleven.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4eleven.write('<br /><a id="000">youreleven<b>&Xi;</b> @Content</a>\n')
            fileobject4eleven.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4eleven.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4eleven)         
            #      
        
        
        KB2name4eleven = {}
        key2name4eleven = 0
                 
        for file2walk in DirectoryWalker(path2eleven):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4eleven [key2name4eleven] = file2walk
                    print ("KB2NAME4ELEVEN[", key2name4eleven, "]: ", KB2name4eleven [key2name4eleven])
                    # KB2NAME4ELEVEN[ 0 ]:  F://temp//yophotos//test2eleven//a
                    # ...
                    # KB2NAME4ELEVEN[ 25 ]:  F://temp//yophotos//test2eleven//z
                    # KB2NAME4ELEVEN[ 26 ]:  F://temp//yophotos//test2eleven//s\syysmetsastys09september2005
                    # ...
                    
                    key2name4eleven = key2name4eleven + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2ELEVEN4SEARCH - FAILED UPDATING KB2NAME4ELEVEN WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4eleven(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4eleven.write('<br /> \n')
            fileobject4eleven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4eleven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4eleven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4eleven.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4eleven.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4eleven.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4eleven.write('</p>\n')
            # 
            fileobject4eleven.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4eleven)         
            #            
        try:    
            fileobject4eleven.close()
            print("(Step 4C/33) OF SHOOT2ELEVEN4SEARCH - CLOSED OUTPUT: ", fileobject4eleven)         
            # SHOOT2ELEVEN4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2eleven//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4eleven)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2ELEVEN4SEARCH - STARTING TO ANALYSE KB2NAME4ELEVEN: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4ELEVEN:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4eleven  = {}
        AlphaKB4eleven['a'] = {}
        AlphaKB4eleven['b'] = {}
        AlphaKB4eleven['c'] = {}
        AlphaKB4eleven['d'] = {}
        AlphaKB4eleven['e'] = {}
        AlphaKB4eleven['f'] = {}
        AlphaKB4eleven['g'] = {}
        AlphaKB4eleven['h'] = {}
        AlphaKB4eleven['i'] = {}
        AlphaKB4eleven['j'] = {}
        AlphaKB4eleven['k'] = {}
        AlphaKB4eleven['l'] = {}
        AlphaKB4eleven['m'] = {}
        AlphaKB4eleven['n'] = {}
        AlphaKB4eleven['o'] = {}
        AlphaKB4eleven['p'] = {}
        AlphaKB4eleven['q'] = {}
        AlphaKB4eleven['r'] = {}
        AlphaKB4eleven['s'] = {}
        AlphaKB4eleven['t'] = {}
        AlphaKB4eleven['u'] = {}
        AlphaKB4eleven['v'] = {}
        AlphaKB4eleven['w'] = {}
        AlphaKB4eleven['x'] = {}
        AlphaKB4eleven['y'] = {}
        AlphaKB4eleven['z'] = {} 
        keys2AlphaKB4eleven = AlphaKB4eleven.keys()
        key2AlphaKB4eleven  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4eleven = len(path2eleven)
        # 
        
        keys2name4eleven = KB2name4eleven.keys()
                
        for key2name4eleven in sorted(keys2name4eleven):
            # 
            name2optimize4eleven = KB2name4eleven[key2name4eleven]
            # 
            shortcut2level4eleven = name2optimize4eleven[len2cut4eleven:]
            # 
            len2shortcut4eleven = len(shortcut2level4eleven)
            if len2shortcut4eleven == 1:
                try:
                    # LEVEL ELEVEN CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4eleven in keys2AlphaKB4eleven:
                        KB2level1[key2level1] = shortcut2level4eleven
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2ELEVEN4SEARCH ** WARNING - SHORTCUT2LEVEL4ELEVEN: ", shortcut2level4eleven, " NOT IN KEYS2ALPHAKB4ELEVEN: ", keys2AlphaKB4eleven)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2ELEVEN4SEARCH *** FAILED - SHORTCUT2LEVEL4ELEVEN: ", shortcut2level4eleven)      
            else:
                try:
                    
                    string2search4eleven = '\\'
                    shortcut2level4eleven = shortcut2level4eleven[2:]
                    
                    index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                    if index2level4eleven == -1:
                         
                        KB2level2[key2level2] = shortcut2level4eleven
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                        index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                        if index2level4eleven == -1:
                            KB2level3[key2level3] = shortcut2level4eleven
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                            index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                            if index2level4eleven == -1:
                                KB2level4[key2level4] = shortcut2level4eleven
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                                index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                                if index2level4eleven == -1:
                                    KB2level5[key2level5] = shortcut2level4eleven
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                                    index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                                    if index2level4eleven == -1:
                                        KB2level6[key2level6] = shortcut2level4eleven
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                                        index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                                        if index2level4eleven == -1:
                                            KB2level7[key2level7] = shortcut2level4eleven
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4eleven = shortcut2level4eleven[index2level4eleven+1:]
                                            index2level4eleven=str.find(shortcut2level4eleven,string2search4eleven)
                                            if index2level4eleven == -1:
                                                KB2level8[key2level8] = shortcut2level4eleven
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2ELEVEN4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4ELEVEN: ", shortcut2level4eleven)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2ELEVEN4SEARCH *** FAILED - SHORTCUT2LEVEL4ELEVEN: ", shortcut2level4eleven)   
        
        print ("(Step 6A/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # elevenfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2ELEVEN4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2ELEVEN4SEARCH - COUNT2ACK4ELEVEN; ", count2ack4eleven)
            # COUNT2ACK4ELEVEN;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2ELEVEN4SEARCH - COUNT2NACK4ELEVEN; ", count2nack4eleven)
            # COUNT2NACK4ELEVEN;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2ELEVEN4SEARCH - COUNT2FOUND4ELEVEN: ", count2found4eleven)
            # COUNT2FOUND4ELEVEN:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2ELEVEN4SEARCH - FOUND MAX SIZE: ", maxsize2ack4eleven)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2ELEVEN4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4eleven)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4eleven == 0:
                meansize2ack4eleven = 0
                print ("(Step 7G1/33) OF SHOOT2ELEVEN4SEARCH - MEAN SIZE SET: ", meansize2ack4eleven)
                #  
            else:       
                meansize2ack4eleven = int(sumsize2ack4eleven / count2ack4eleven)
                print ("(Step 7G2/33) OF SHOOT2ELEVEN4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4eleven, ", WHERE SUMSIZE2ACK4ELEVEN: ", sumsize2ack4eleven, " COUNT2ACK4ELEVEN: ", count2ack4eleven)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4ELEVEN:  10944512  COUNT2ACK4ELEVEN:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4eleven < maxsize2file4eleven:
                print ("(Step 7H/33) OF SHOOT2ELEVEN4SEARCH - MIN SIZE MET: ", minsize2ack4eleven)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2ELEVEN4SEARCH ** MIN DEFINED: ", minsize2ack4eleven, " EQUALS TO MAXSIZE2FILE4ELEVEN: ", maxsize2file4eleven)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2ELEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2ELEVEN4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2ELEVEN4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2ELEVEN4SEARCH - QUEUE2ELEVEN: ", queue2eleven)
        print("(STEP 7Z3/33) OF SHOOT2ELEVEN4SEARCH - CONSUMER_CHANNEL2ELEVEN: ", consumer_channel2eleven) 
        print("(STEP 7Z4/33) OF SHOOT2ELEVEN4SEARCH - PUBLISHER_CHANNEL2ELEVEN: ", publisher_channel2eleven)
        print("(STEP 7Z5/33) OF SHOOT2ELEVEN4SEARCH - PATH2ELEVEN: ", path2eleven)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.elevenxi.com; www.yourelevenxi.com; www.yourelevenxi.org; www.eleven2xi.com/; www.eleven4xi.com/; www.eleven8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2eleven4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
